Index: GraphicsMagick-1.2.5/coders/png.c
===================================================================
--- GraphicsMagick-1.2.5.orig/coders/png.c	2018-01-19 20:08:30.737576639 +0100
+++ GraphicsMagick-1.2.5/coders/png.c	2018-01-19 20:29:20.474317244 +0100
@@ -6030,27 +6363,13 @@ ModuleExport void UnregisterPNGImage(voi
 */
 
 
-#if (PNG_LIBPNG_VER > 99 && PNG_LIBPNG_VER < 10007)
-/* This function became available in libpng version 1.0.6g. */
-static void
-png_set_compression_buffer_size(png_structp png_ptr, png_uint_32 size)
-{
-  if (png_ptr->zbuf)
-    png_free(png_ptr, png_ptr->zbuf); png_ptr->zbuf=NULL;
-  png_ptr->zbuf_size=(png_size_t) size;
-  png_ptr->zbuf=(png_bytep) png_malloc(png_ptr, size);
-  if (!png_ptr->zbuf)
-    png_error(png_ptr,"Unable to allocate zbuf");
-}
-#endif
-
 static void
 png_write_raw_profile(const ImageInfo *image_info,png_struct *ping,
                       png_info *ping_info, const char *profile_type,
-                      const char *profile_description, const unsigned char *profile_data,
+                      const char *profile_description,
+                      const unsigned char *profile_data,
                       png_uint_32 length)
 {
-#if (PNG_LIBPNG_VER > 10005)
   png_textp
     text;
 
@@ -6069,40 +6388,28 @@ png_write_raw_profile(const ImageInfo *i
 
   unsigned char
     hex[16]={'0','1','2','3','4','5','6','7','8','9','a','b','c','d','e','f'};
-#endif
 
-#if (PNG_LIBPNG_VER <= 10005)
-  if (image_info->verbose)
-    (void) printf("Not ");
-  (void) image_info;
-  (void) ping;
-  (void) ping_info;
-  (void) profile_type;
-  (void) profile_description;
-  (void) profile_data;
-  (void) length;
-#endif
   if (image_info->verbose)
     {
       (void) printf("writing raw profile: type=%.1024s, length=%lu\n",
-                    profile_type, length);
+                    profile_type, (unsigned long)length);
     }
-#if (PNG_LIBPNG_VER > 10005)
-# if PNG_LIBPNG_VER >= 14000
+#if PNG_LIBPNG_VER >= 14000
   text=(png_textp) png_malloc(ping,(png_alloc_size_t) sizeof(png_text));
-# else
+#else
   text=(png_textp) png_malloc(ping,(png_size_t) sizeof(png_text));
-# endif
-  description_length=strlen((const char *) profile_description);
+#endif
+  description_length=(png_uint_32) strlen((const char *) profile_description);
   allocated_length=(png_uint_32) (length*2 + (length >> 5) + 20
                                   + description_length);
-# if PNG_LIBPNG_VER >= 14000
-  text[0].text=(png_charp) png_malloc(ping, (png_alloc_size_t) allocated_length);
-  text[0].key=(png_charp) png_malloc(ping, (png_alloc_size_t) 80);
-# else
-  text[0].text=(png_charp) png_malloc(ping, (png_size_t) allocated_length);
-  text[0].key=(png_charp) png_malloc(ping, (png_size_t) 80);
-# endif
+#if PNG_LIBPNG_VER >= 14000
+   text[0].text=(png_charp) png_malloc(ping,
+      (png_alloc_size_t) allocated_length);
+   text[0].key=(png_charp) png_malloc(ping, (png_alloc_size_t) 80);
+#else
+   text[0].text=(png_charp) png_malloc(ping, (png_size_t) allocated_length);
+   text[0].key=(png_charp) png_malloc(ping, (png_size_t) 80);
+#endif
   text[0].key[0]='\0';
   (void) strcat(text[0].key, "Raw profile type ");
   (void) strncat(text[0].key, (const char *) profile_type, 61);
@@ -6112,7 +6419,7 @@ png_write_raw_profile(const ImageInfo *i
   (void) strcpy(dp,(const char *) profile_description);
   dp+=description_length;
   *dp++='\n';
-  (void) sprintf(dp,"%8lu ",length);
+  (void) sprintf(dp,"%8lu ",(unsigned long)length);
   dp+=8;
   for (i=0; i < (long) length; i++)
     {
@@ -6132,12 +6439,27 @@ png_write_raw_profile(const ImageInfo *i
   png_free(ping,text[0].text);
   png_free(ping,text[0].key);
   png_free(ping,text);
-#endif
 }
 
-static unsigned int WriteOnePNGImage(MngInfo *mng_info,
-                                     const ImageInfo *image_info,Image *image)
+static MagickPassFail WriteOnePNGImage(MngInfo *mng_info,
+                                       const ImageInfo *image_info,Image *imagep)
 {
+  const char
+    *gm_vers,
+    *libpng_runv,
+    *libpng_vers,
+    *zlib_runv,
+    *zlib_vers;
+
+#ifdef HasLCMS
+  char
+    lcms_vers[32];
+#endif
+
+  Image
+    * volatile imagev = imagep,  /* Use only 'imagev' before setjmp() */
+    *image;                      /* Use only 'image' after setjmp() */
+
   /* Write one PNG image */
   const ImageAttribute
     *attribute;
@@ -6147,21 +6469,41 @@ static unsigned int WriteOnePNGImage(Mng
 
   int
     num_passes,
-    pass;
+    pass,
+    ping_bit_depth = 0,
+    ping_colortype = 0,
+    ping_interlace_method = 0,
+    ping_compression_method = 0;
+
+  volatile int
+    ping_filter_method = 0,
+    ping_num_trans = 0,
+    ping_valid_trns = 0;
+
+  volatile png_bytep
+    ping_trans_alpha = NULL;
 
   png_colorp
     palette;
 
+  png_color_16
+    ping_background,
+    ping_trans_color;
+
   png_info
     *ping_info;
 
   png_struct
     *ping;
 
+  png_uint_32
+    ping_width,
+    ping_height;
+
   long
     y;
 
-  register IndexPacket
+  register const IndexPacket
     *indexes;
 
   register long
@@ -6172,9 +6514,11 @@ static unsigned int WriteOnePNGImage(Mng
     *png_pixels;
 
   unsigned int
+    image_colors,
+    image_depth,
+    image_matte,
     logging,
-    matte,
-    not_valid;
+    matte;
 
   unsigned long
     quantum_size,  /* depth for ExportImage */
@@ -6187,67 +6531,85 @@ static unsigned int WriteOnePNGImage(Mng
   logging=LogMagickEvent(CoderEvent,GetMagickModule(),
                          "  enter WriteOnePNGImage()");
 
-  /*
-    Make sure that image is in an RGB type space.
-  */
-  (void) TransformColorspace(image,RGBColorspace);
-  
-  /*
-    Analyze image to be written.
-  */
-  if (!GetImageCharacteristics(image,&characteristics,
-                               (OptimizeType == image_info->type),
-                               &image->exception))
-    {
-      CloseBlob(image);
-      return MagickFail;
-    }
+  if (imagev == (Image *) NULL)
+    return(MagickFalse);
 
-  if (image->storage_class == PseudoClass &&
-      image->colors <= 256)
-    {
-      mng_info->IsPalette=MagickTrue;
-      image->depth=8;
-    }
-
-  if (mng_info->write_png8 || mng_info->write_png24 || mng_info->write_png32)
-    image->depth=8;
-  else if (image->depth < 8)
-    image->depth=8;
-  else if (image->depth > 8 && image->depth < 16)
-    image->depth=16;
-  else if (image->depth > 16)
-    image->depth=16;
+  /* Define these outside of the following "if logging()" block so they will
+   * show in debuggers.
+   */
+    gm_vers=MagickLibVersionText;
+#ifdef HasLCMS
+    (void) sprintf(lcms_vers,"%.4d",LCMS_VERSION);
+#endif
+    libpng_runv=png_get_libpng_ver(NULL);
+    libpng_vers=PNG_LIBPNG_VER_STRING;
+    zlib_runv=zlib_version;
+    zlib_vers=ZLIB_VERSION;
+
+  if (logging != MagickFalse)
+    {
+       (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+            "    GM version     = %.31s", gm_vers);
+       (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+            "    Libpng version = %.31s", libpng_vers);
+       if (LocaleCompare(libpng_vers,libpng_runv) != 0)
+       {
+       (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+            "      running with   %.31s", libpng_runv);
+       }
+       (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+            "    Zlib version   = %.31s", zlib_vers);
+       if (LocaleCompare(zlib_vers,zlib_runv) != 0)
+       {
+       (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+            "      running with   %.31s", zlib_runv);
+       }
+#ifdef HasLCMS
+       (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+            "    LCMS version   = %.31s", lcms_vers);
+#endif
+    }
+  /* Initialize some stuff */
+  ping_background.red = 0;
+  ping_background.green = 0;
+  ping_background.blue = 0;
+  ping_background.gray = 0;
+  ping_background.index = 0;
+
+  ping_trans_color.red=0;
+  ping_trans_color.green=0;
+  ping_trans_color.blue=0;
+  ping_trans_color.gray=0;
 
   /*
     Allocate the PNG structures
   */
 #ifdef PNG_USER_MEM_SUPPORTED
-  ping=png_create_write_struct_2(PNG_LIBPNG_VER_STRING,image,
+  ping=png_create_write_struct_2(PNG_LIBPNG_VER_STRING,imagev,
                                  PNGErrorHandler,PNGWarningHandler,
                                  (void *) NULL,
                                  (png_malloc_ptr) png_IM_malloc,
                                  (png_free_ptr) png_IM_free);
 #else
-  ping=png_create_write_struct(PNG_LIBPNG_VER_STRING,image,
+  ping=png_create_write_struct(PNG_LIBPNG_VER_STRING,imagev,
                                PNGErrorHandler,PNGWarningHandler);
 #endif
   if (ping == (png_struct *) NULL)
-    ThrowWriterException(ResourceLimitError,MemoryAllocationFailed,image);
+    ThrowWriterException(ResourceLimitError,MemoryAllocationFailed,imagev);
   ping_info=png_create_info_struct(ping);
   if (ping_info == (png_info *) NULL)
     {
       png_destroy_write_struct(&ping,(png_info **) NULL);
-      ThrowWriterException(ResourceLimitError,MemoryAllocationFailed,image);
+      ThrowWriterException(ResourceLimitError,MemoryAllocationFailed,imagev);
     }
-  png_set_write_fn(ping,image,png_put_data,png_flush_data);
+  png_set_write_fn(ping,imagev,png_put_data,png_flush_data);
   png_pixels=(unsigned char *) NULL;
 
 #if defined(PNG_SETJMP_NOT_THREAD_SAFE)
   AcquireSemaphoreInfo(&png_semaphore);
 #endif
 
-  if (setjmp(ping->jmpbuf))
+  if (setjmp(png_jmpbuf(ping)))
     {
       /*
         PNG write failed.
@@ -6261,130 +6623,142 @@ static unsigned int WriteOnePNGImage(Mng
 #if defined(PNG_SETJMP_NOT_THREAD_SAFE)
       LiberateSemaphoreInfo(&png_semaphore);
 #endif
-      return(False);
+      return(MagickFail);
     }
+
+/* { For navigation to end of setjmp-controlled block */
+
+#ifdef PNG_BENIGN_ERRORS_SUPPORTED
+  /* Allow benign errors */
+  png_set_benign_errors(ping, 1);
+#endif
+
+  image=imagev;  /* Use 'image' after this point for optimization */
+
+  /*
+    Make sure that image is in an RGB type space.
+  */
+  if (!TransformColorspace(image,RGBColorspace))
+    {
+      CloseBlob(image);
+#if defined(PNG_SETJMP_NOT_THREAD_SAFE)
+      LiberateSemaphoreInfo(&png_semaphore);
+#endif
+      return MagickFail;
+    }
+
+  /*
+    Analyze image to be written.
+  */
+  if (!GetImageCharacteristics(image,&characteristics,
+                               (OptimizeType == image_info->type),
+                               &image->exception))
+    {
+      CloseBlob(image);
+#if defined(PNG_SETJMP_NOT_THREAD_SAFE)
+      LiberateSemaphoreInfo(&png_semaphore);
+#endif
+      return MagickFail;
+    }
+
+  if (logging)
+    {
+      (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+                            "  Image Characteristics:\n"
+                            "    CMYK:       %u\n"
+                            "    Grayscale:  %u\n"
+                            "    Monochrome: %u\n"
+                            "    Opaque:     %u\n"
+                            "    Palette:    %u",
+                            characteristics.cmyk,
+                            characteristics.grayscale ,
+                            characteristics.monochrome,
+                            characteristics.opaque,
+                            characteristics.palette);
+    }
+
+  if (image->storage_class == PseudoClass)
+    image_colors=image->colors;
+  else
+    image_colors=0;
+
+  image_depth=image->depth;
+  image_matte=image->matte;
+
+  if (image->storage_class == PseudoClass &&
+      image_colors <= 256)
+    {
+      mng_info->IsPalette=MagickTrue;
+      image_depth=8;
+    }
+
+  if (mng_info->write_png8 || mng_info->write_png24 || mng_info->write_png32)
+    image_depth=8;
+
+  else if (mng_info->write_png48 || mng_info->write_png64)
+      image_depth=16;
+
+  else if (image_depth < 8)
+    image_depth=8;
+
+  else if (image_depth > 8)
+    image_depth=16;
+
   /*
     Prepare PNG for writing.
   */
+
 #if defined(PNG_MNG_FEATURES_SUPPORTED)
   if (mng_info->write_mng)
+  {
+# ifdef PNG_WRITE_CHECK_FOR_INVALID_INDEX_SUPPORTED
+    /* Disable new libpng-1.5.10 feature when writing a MNG */
+    png_set_check_for_invalid_index (ping, 0);
+# endif
     (void) png_permit_mng_features(ping,PNG_ALL_MNG_FEATURES);
+  }
 #else
 # ifdef PNG_WRITE_EMPTY_PLTE_SUPPORTED
   if (mng_info->write_mng)
-    png_permit_empty_plte(ping,True);
+    png_permit_empty_plte(ping,MagickTrue);
 # endif
 #endif
   x=0;
-  ping_info->width=image->columns;
-  ping_info->height=image->rows;
+  ping_width=image->columns;
+  ping_height=image->rows;
   if (logging)
     {
       (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                            "    width=%lu",ping_info->width);
+                            "    width=%lu",
+                            (unsigned long)ping_width);
+      (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+                            "    height=%lu",
+                            (unsigned long)ping_height);
       (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                            "    height=%lu",ping_info->height);
+                            "    image->depth=%u",image_depth);
       (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                            "    image->depth=%u",image->depth);
+                            "  image_colors=%u",image_colors);
     }
 
 
-  quantum_size=(image->depth > 8) ? 16:8;
+  quantum_size=(image_depth > 8) ? 16:8;
 
-  save_image_depth=image->depth;
-  ping_info->bit_depth=(png_byte) save_image_depth;
+  save_image_depth=image_depth;
+  ping_bit_depth=(png_byte) save_image_depth;
   if (logging)
     {
       (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                            "    ping_info->bit_depth=%u",ping_info->bit_depth);
-    }
-#if defined(PNG_pHYs_SUPPORTED)
-  if ((image->x_resolution != 0) && (image->y_resolution != 0) &&
-      (!mng_info->write_mng || !mng_info->equal_physs))
-    {
-      int
-        unit_type;
-
-      png_uint_32
-        x_resolution,
-        y_resolution;
-
-      if (image->units == PixelsPerInchResolution)
-        {
-          unit_type=PNG_RESOLUTION_METER;
-          x_resolution=(png_uint_32) (100.0*image->x_resolution/2.54);
-          y_resolution=(png_uint_32) (100.0*image->y_resolution/2.54);
-        }
-      else if (image->units == PixelsPerCentimeterResolution)
-        {
-          unit_type=PNG_RESOLUTION_METER;
-          x_resolution=(png_uint_32) (100.0*image->x_resolution);
-          y_resolution=(png_uint_32) (100.0*image->y_resolution);
-        }
-      else
-        {
-          unit_type=PNG_RESOLUTION_UNKNOWN;
-          x_resolution=(png_uint_32) image->x_resolution;
-          y_resolution=(png_uint_32) image->y_resolution;
-        }
-      png_set_pHYs(ping,ping_info,x_resolution,y_resolution,unit_type);
-      if (logging)
-        (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                              "    Setting up pHYs chunk");
-    }
-#endif
-#if defined(PNG_oFFs_SUPPORTED)
-  if (mng_info->write_mng == 0 && (image->page.x || image->page.y))
-    {
-      png_set_oFFs(ping,ping_info,(png_int_32) image->page.x,
-                   (png_int_32) image->page.y, 0);
-      if (logging)
-        (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                              "    Setting up oFFs chunk");
-    }
-#endif
-  if (image->matte && (!mng_info->adjoin || !mng_info->equal_backgrounds))
-    {
-      png_color_16
-        background;
-
-      if (image->depth < QuantumDepth)
-        {
-          int
-            maxval;
-
-          maxval=(1 << image->depth)-1;
-          background.red=(png_uint_16)
-            (maxval*image->background_color.red/MaxRGB);
-          background.green=(png_uint_16)
-            (maxval*image->background_color.green/MaxRGB);
-          background.blue=(png_uint_16)
-            (maxval*image->background_color.blue/MaxRGB);
-          background.gray=(png_uint_16)
-            (maxval*PixelIntensity(&image->background_color)/MaxRGB);
-        }
-      else
-        {
-          background.red=image->background_color.red;
-          background.green=image->background_color.green;
-          background.blue=image->background_color.blue;
-          background.gray=
-            (png_uint_16) PixelIntensity(&image->background_color);
-        }
-      background.index=(png_byte) background.gray;
-      if (logging)
-        (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                              "    Setting up bKGD chunk");
-      png_set_bKGD(ping,ping_info,&background);
+                            "    ping_bit_depth=%u",
+                            ping_bit_depth);
     }
   /*
     Select the color type.
   */
-  matte=image->matte;
+  matte=image_matte;
   if (mng_info->write_png8)
     {
-      ping_info->color_type=PNG_COLOR_TYPE_PALETTE;
-      ping_info->bit_depth=8;
+      ping_colortype=PNG_COLOR_TYPE_PALETTE;
+      ping_bit_depth=8;
       {
         /* TO DO: make this a function cause it's used twice, except
            for reducing the sample depth from 8. */
@@ -6393,11 +6767,10 @@ static unsigned int WriteOnePNGImage(Mng
           quantize_info;
 
         unsigned long
-          number_colors,
-          save_number_colors;
+          number_colors;
 
-        number_colors=image->colors;
-        if (number_colors == 0 || number_colors > 256)
+        number_colors=image_colors;
+        if ((number_colors == 0) || (number_colors > 256))
           {
             GetQuantizeInfo(&quantize_info);
             quantize_info.dither=image_info->dither;
@@ -6406,185 +6779,180 @@ static unsigned int WriteOnePNGImage(Mng
             number_colors=image->colors;
             if (logging)
               (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                                    "    Colors quantized to %ld",number_colors);
+                                    "    Colors quantized to %ld",
+                                    number_colors);
+            image_colors=image->colors;
           }
-        if (matte)
-          ping_info->valid|=PNG_INFO_tRNS;
+
         /*
           Set image palette.
         */
-        ping_info->color_type=PNG_COLOR_TYPE_PALETTE;
-        ping_info->valid|=PNG_INFO_PLTE;
-#if defined(PNG_SORT_PALETTE)
-        save_number_colors=image->colors;
-        (void) CompressColormapTransFirst(image);
-        number_colors=image->colors;
-        image->colors=save_number_colors;
-#endif
+
+        ping_colortype=PNG_COLOR_TYPE_PALETTE;
+
+        if (logging)
+          (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+                                "  Setting up PLTE chunk with %d colors",
+                                (int) number_colors);
         palette=MagickAllocateMemory(png_color *,
                                      number_colors*sizeof(png_color));
         if (palette == (png_color *) NULL)
-          ThrowWriterException(ResourceLimitError,MemoryAllocationFailed,
-                               image);
-        if (logging)
-          (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                                "  Setting up PLTE chunk");
-        for (i=0; i < (long) number_colors; i++)
-          {
-            palette[i].red=ScaleQuantumToChar(image->colormap[i].red);
-            palette[i].green=ScaleQuantumToChar(image->colormap[i].green);
-            palette[i].blue=ScaleQuantumToChar(image->colormap[i].blue);
-            if (logging)
-              (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+          png_error(ping, "Could not allocate palette");
+        else
+        {
+          for (i=0; i < (long) number_colors; i++)
+            {
+              palette[i].red=ScaleQuantumToChar(image->colormap[i].red);
+              palette[i].green=ScaleQuantumToChar(image->colormap[i].green);
+              palette[i].blue=ScaleQuantumToChar(image->colormap[i].blue);
+              if (logging)
+                (void) LogMagickEvent(CoderEvent,GetMagickModule(),
 #if QuantumDepth == 8
-                                    "    %3ld (%3d,%3d,%3d)",
+                                      "    %3ld (%3d,%3d,%3d)",
 #else
-                                    "    %5ld (%5d,%5d,%5d)",
+                                      "    %5ld (%5d,%5d,%5d)",
 #endif
-                                    i,palette[i].red,palette[i].green,palette[i].blue);
+                                      i,palette[i].red,palette[i].green,
+                                      palette[i].blue);
 
-          }
-        png_set_PLTE(ping,ping_info,palette,(int) number_colors);
-#if (PNG_LIBPNG_VER > 10008)
-        MagickFreeMemory(palette);
-#endif
+            }
+          png_set_PLTE(ping,ping_info,palette,(int) number_colors);
+          MagickFreeMemory(palette);
+        }
         /*
           Identify which colormap entry is transparent.
         */
-        ping_info->trans=MagickAllocateMemory(unsigned char *,number_colors);
-        if (ping_info->trans == (unsigned char *) NULL)
-          ThrowWriterException(ResourceLimitError,MemoryAllocationFailed,
-                               image);
-        assert(number_colors <= 256);
-        for (i=0; i < (long) number_colors; i++)
-          ping_info->trans[i]=255;
-        for (y=0; y < (long) image->rows; y++)
+        ping_trans_alpha=MagickAllocateMemory(unsigned char *, number_colors);
+        if (ping_trans_alpha == (unsigned char *) NULL)
+          png_error(ping, "Could not allocate ping_trans_alpha");
+        else
           {
-            register const PixelPacket
-              *p=NULL;
-
-            p=AcquireImagePixels(image,0,y,image->columns,1,
-                                 &image->exception);
-            if (p == (const PixelPacket *) NULL)
-              break;
-            indexes=GetIndexes(image);
-            for (x=0; x < (long) image->columns; x++)
+            assert(number_colors <= 256);
+            for (i=0; i < (long) number_colors; i++)
+              ping_trans_alpha[i]=255;
+            for (y=0; y < (long) image->rows; y++)
               {
-                if (p->opacity != OpaqueOpacity)
+                register const PixelPacket
+                  *p=NULL;
+
+                p=AcquireImagePixels(image,0,y,image->columns,1,
+                                     &image->exception);
+                if (p == (const PixelPacket *) NULL)
+                  break;
+                indexes=GetIndexes(image);
+                for (x=0; x < (long) image->columns; x++)
                   {
-                    IndexPacket
-                      index;
+                    if (p->opacity != OpaqueOpacity)
+                      {
+                        IndexPacket
+                          index;
 
-                    index=indexes[x];
-                    assert((unsigned long) index < number_colors);
-                    ping_info->trans[index]=(png_byte) (255-
-                                                        ScaleQuantumToChar(p->opacity));
+                        index=indexes[x];
+                        assert((unsigned long) index < number_colors);
+                        ping_trans_alpha[index]=(png_byte) (255-
+                                                ScaleQuantumToChar(p->opacity));
+                      }
+                    p++;
                   }
-                p++;
               }
+            ping_num_trans=0;
+            for (i=0; i < (long) number_colors; i++)
+              if (ping_trans_alpha[i] != 255)
+                ping_num_trans=(unsigned short) (i+1);
+            if (ping_num_trans != 0)
+              ping_valid_trns = 1;
+            MagickFreeMemory(ping_trans_alpha);
           }
-        ping_info->num_trans=0;
-        for (i=0; i < (long) number_colors; i++)
-          if (ping_info->trans[i] != 255)
-            ping_info->num_trans=(unsigned short) (i+1);
-        if (ping_info->num_trans == 0)
-          ping_info->valid&=(~PNG_INFO_tRNS);
-        if (!(ping_info->valid & PNG_INFO_tRNS))
-          ping_info->num_trans=0;
-        if (ping_info->num_trans == 0)
-          MagickFreeMemory(ping_info->trans);
         /*
           Identify which colormap entry is the background color.
         */
         for (i=0; i < (long) Max(number_colors-1,1); i++)
-          if (RGBColorMatchExact(ping_info->background,image->colormap[i]))
+          if (RGBColorMatchExact(ping_background,image->colormap[i]))
             break;
-        ping_info->background.index=(png_uint_16) i;
+        ping_background.index=(png_uint_16) i;
       }
-      if (image->matte)
+      if (image_matte)
         {
           /* TO DO: reduce to binary transparency */
         }
     }
-  else if (mng_info->write_png24)
+  else if (mng_info->write_png24 || mng_info->write_png48)
     {
-      image->matte=False;
-      ping_info->color_type=PNG_COLOR_TYPE_RGB;
+      image_matte=MagickFalse;
+      ping_colortype=PNG_COLOR_TYPE_RGB;
     }
-  else if (mng_info->write_png32)
+  else if (mng_info->write_png32 || mng_info->write_png64)
     {
-      image->matte=True;
-      ping_info->color_type=PNG_COLOR_TYPE_RGB_ALPHA;
+      image_matte=MagickTrue;
+      ping_colortype=PNG_COLOR_TYPE_RGB_ALPHA;
     }
   else
     {
-      if (ping_info->bit_depth < 8)
-        ping_info->bit_depth=8;
+      if (ping_bit_depth < 8)
+        ping_bit_depth=8;
 
-      ping_info->color_type=PNG_COLOR_TYPE_RGB;
+      ping_colortype=PNG_COLOR_TYPE_RGB;
       if (characteristics.monochrome)
         {
           if (characteristics.opaque)
             {
-              ping_info->color_type=PNG_COLOR_TYPE_GRAY;
-              ping_info->bit_depth=1;
+              ping_colortype=PNG_COLOR_TYPE_GRAY;
+              ping_bit_depth=1;
             }
           else
             {
-              ping_info->color_type=PNG_COLOR_TYPE_GRAY_ALPHA;
+              ping_colortype=PNG_COLOR_TYPE_GRAY_ALPHA;
             }
         }
       else if (characteristics.grayscale)
         {
           if (characteristics.opaque)
-            ping_info->color_type=PNG_COLOR_TYPE_GRAY;
+            ping_colortype=PNG_COLOR_TYPE_GRAY;
           else
-            ping_info->color_type=PNG_COLOR_TYPE_GRAY_ALPHA;
+            ping_colortype=PNG_COLOR_TYPE_GRAY_ALPHA;
         }
-      else if (characteristics.palette && image->colors <= 256)
+      else if (characteristics.palette && image_colors <= 256)
         {
-          ping_info->color_type=PNG_COLOR_TYPE_PALETTE;
-          ping_info->bit_depth=8;
+          ping_colortype=PNG_COLOR_TYPE_PALETTE;
+          ping_bit_depth=8;
           mng_info->IsPalette=MagickTrue;
         }
       else
         {
           if (characteristics.opaque)
-            ping_info->color_type=PNG_COLOR_TYPE_RGB;
+            ping_colortype=PNG_COLOR_TYPE_RGB;
           else
-            ping_info->color_type=PNG_COLOR_TYPE_RGB_ALPHA;
+            ping_colortype=PNG_COLOR_TYPE_RGB_ALPHA;
         }
       if (image_info->type == BilevelType)
         {
           if (characteristics.monochrome)
             {
-              if (!image->matte)
-                ping_info->bit_depth=1;
+              if (!image_matte)
+                ping_bit_depth=1;
             }
         }
       if (image_info->type == GrayscaleType)
-        ping_info->color_type=PNG_COLOR_TYPE_GRAY;
+        ping_colortype=PNG_COLOR_TYPE_GRAY;
       if (image_info->type == GrayscaleMatteType)
-        ping_info->color_type=PNG_COLOR_TYPE_GRAY_ALPHA;
-      /*       if (!mng_info->optimize && matte) */
-      /*         ping_info->color_type=PNG_COLOR_TYPE_RGB_ALPHA; */
+        ping_colortype=PNG_COLOR_TYPE_GRAY_ALPHA;
 
       if (logging)
         {
           (void) LogMagickEvent(CoderEvent,GetMagickModule(),
                                 "    Tentative PNG color type: %s (%d)",
-                                PngColorTypeToString(ping_info->color_type),
-                                ping_info->color_type);
+                                PngColorTypeToString(ping_colortype),
+                                ping_colortype);
           (void) LogMagickEvent(CoderEvent,GetMagickModule(),
                                 "    image_info->type: %d",image_info->type);
           (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                                "    image->depth: %u",image->depth);
+                                "    image->depth: %u",image_depth);
           (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                                "    ping_info->bit_depth: %d",
-                                ping_info->bit_depth);
+                                "    ping_bit_depth: %d",
+                                ping_bit_depth);
         }
 
-      if (matte && (mng_info->optimize || mng_info->IsPalette))
+      if (matte && mng_info->IsPalette)
         {
           register const PixelPacket
             *p=NULL;
@@ -6593,10 +6961,11 @@ static unsigned int WriteOnePNGImage(Mng
             {
               /*
                 No transparent pixels are present.  Change 4 or 6 to 0 or 2,
-                and do not set the PNG_INFO_tRNS flag in ping_info->valid.
+                and unset the ping_valid_trns flag.
               */
-              image->matte=False;
-              ping_info->color_type&=0x03;
+              image_matte=MagickFalse;
+              ping_colortype&=0x03;
+              ping_valid_trns=0;
             }
           else
             {
@@ -6607,13 +6976,13 @@ static unsigned int WriteOnePNGImage(Mng
                 opaque = MagickTrue;
 
               mask=0xffff;
-              if (ping_info->bit_depth == 8)
+              if (ping_bit_depth == 8)
                 mask=0x00ff;
-              if (ping_info->bit_depth == 4)
+              if (ping_bit_depth == 4)
                 mask=0x000f;
-              if (ping_info->bit_depth == 2)
+              if (ping_bit_depth == 2)
                 mask=0x0003;
-              if (ping_info->bit_depth == 1)
+              if (ping_bit_depth == 1)
                 mask=0x0001;
 
               /*
@@ -6621,7 +6990,8 @@ static unsigned int WriteOnePNGImage(Mng
               */
               for (y=0; y < (long) image->rows; y++)
                 {
-                  p=AcquireImagePixels(image,0,y,image->columns,1,&image->exception);
+                  p=AcquireImagePixels(image,0,y,image->columns,1,
+                                       &image->exception);
                   if (p == (const PixelPacket *) NULL)
                     break;
                   for (x=(long) image->columns; x > 0; x--)
